﻿using System.Windows;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Consturctor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            Loaded += Window_Loaded;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 윈도우 로드시 처리하기 - Window_Loaded(sender, e)

        /// <summary>
        /// 윈도우 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            PopulateTreeView();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 트리 뷰 구축하기 - PopulateTreeView()

        /// <summary>
        /// 트리 뷰 구축하기
        /// </summary>
        private void PopulateTreeView()
        {
            Node rootNode = new Node("부모");

            int nodeCount = 1;

            for(int i = 0; i < 2; i++)
            {
                Node childNode = new Node("노드 " + nodeCount++);

                rootNode.ChildNodeList.Add(childNode);

                for(int j = 0; j < 3; j++)
                {
                    Node grandChildNode = new Node("노드" + nodeCount++);

                    childNode.ChildNodeList.Add(grandChildNode);

                    for(int k = 0; k < 2; k++)
                    {
                        grandChildNode.ChildNodeList.Add(new Node("노드" + nodeCount++));
                    }
                }
            }

            Node dummyNode = new Node();

            dummyNode.ChildNodeList.Add(rootNode);

            this.treeView.ItemsSource = dummyNode.ChildNodeList;
        }

        #endregion
    }
}