﻿using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// 노드
    /// </summary>
    public class Node
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 텍스트
        /// </summary>
        private string text;

        /// <summary>
        /// 자식 노드 리스트
        /// </summary>
        private List<Node> childNodeList;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 텍스트 - Text

        /// <summary>
        /// 텍스트
        /// </summary>
        public string Text
        {
            get
            {
                return this.text;
            }
            set
            {
                this.text = value;
            }
        }

        #endregion
        #region 자식 노드 리스트 - ChildNodeList

        /// <summary>
        /// 자식 노드 리스트
        /// </summary>
        public List<Node> ChildNodeList
        {
            get
            {
                if(this.childNodeList == null)
                {
                    this.childNodeList = new List<Node>();
                }

                return this.childNodeList;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - Node()

        /// <summary>
        /// 생성자
        /// </summary>
        public Node()
        {
        }

        #endregion
        #region 생성자 - Node(text)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="text">텍스트</param>
        public Node(string text)
        {
            this.text = text;
        }

        #endregion
    }
}